import 'dart:async';
import 'package:chopper/chopper.dart';

class ApplyHeaderInterceptor extends RequestInterceptor {
  // this callback method is used for getting token for header
  late final String Function() _getHeaderToken;

  // this method allows you to return several other parameters to add in header
  late final Map<String, String> Function()? _getHeaderValues;
  ApplyHeaderInterceptor(
      {required String Function() getHeaderToken,
      Map<String, String> Function()? getHeaderValues}) {
    _getHeaderToken = getHeaderToken;
    _getHeaderValues = getHeaderValues;
  }
  @override
  FutureOr<Request> onRequest(Request request) {
    final String token = _getHeaderToken();
    if (_getHeaderValues != null) {
      // getting all header params to be added
      Map<String, String> headers = _getHeaderValues!();
      headers.forEach((key, value) {
        request = applyHeader(request, key, value);
      });
    }
    // finally returns header by adding last parameter that is token
    return applyHeader(request, 'Authorization', token);
  }
}
